//+------------------------------------------------------------------+
//|                                                    sSpearman.mq5 |
//|                                                      Aleksej1966 |
//|                        https://www.mql5.com/ru/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "Aleksej1966"
#property link      "https://www.mql5.com/ru/users/aleksej1966"
#property version   "1.00"
#property script_show_inputs

input ushort iPeriod=50;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   int period=MathMax(5,iPeriod),handle=FileOpen("Spearman.csv",FILE_WRITE|FILE_CSV);
   double arr1[][2],arr2[][2],denom=period*(period*period-1);

   ArrayResize(arr1,period);
   ArrayResize(arr2,period);

   for(int i=0; i<SymbolsTotal(true)-1; i++)
     {
      string sym1=SymbolName(i,true);
      double point1=SymbolInfoDouble(sym1,SYMBOL_POINT);
      for(int j=i+1; j<SymbolsTotal(true); j++)
        {
         string sym2=SymbolName(j,true);
         int bars=MathMin(iBars(sym1,PERIOD_CURRENT),iBars(sym2,PERIOD_CURRENT))-period-1,cnt=0;
         double correlation=0,point2=SymbolInfoDouble(sym2,SYMBOL_POINT);

         for(int k=bars; k>=0; k--)
           {
            for(int l=0; l<period; l++)
              {
               int pos=k+l;
               arr1[l][0]=MathRound(iOpen(sym1,PERIOD_CURRENT,pos)/point1);
               arr1[l][1]=l;
               arr2[l][0]=MathRound(iOpen(sym2,PERIOD_CURRENT,pos)/point2);
               arr2[l][1]=l;
              }
            ArraySort(arr1);
            ArraySort(arr2);

            double sum=0;
            for(int l=0; l<period; l++)
               for(int m=0; m<period; m++)
                  if(arr1[l][1]==arr2[m][1])
                    {
                     int d=l-m;
                     sum=sum+d*d;
                     break;
                    }

            correlation=correlation+(denom-6*sum)/denom;
            cnt++;
           }

         if(cnt>0)
            FileWrite(handle,sym1,sym2,correlation/cnt);
        }
     }

   FileClose(handle);
   Alert("Done");
//---
  }
//+------------------------------------------------------------------+
